﻿using Ozeki.Media.MediaHandlers;
using Ozeki.Media;
using Ozeki.VoIP;

namespace CallTransfer
{
    class MediaHandlers
    {
        MediaConnector connector;
        Microphone microphone;
        Speaker speaker;
        PhoneCallAudioSender audioSender;               // audio sender for normal calls
        PhoneCallAudioReceiver audioReceiver;           // audio receiver for normal calls
        bool started;

        public MediaHandlers()
        {
            microphone = Microphone.GetDefaultDevice();
            speaker = Speaker.GetDefaultDevice();
            audioSender = new PhoneCallAudioSender();
            audioReceiver = new PhoneCallAudioReceiver();

            connector = new MediaConnector();
            
        }

        public void Start(IPhoneCall call)
        {
            //if (started)
            //    return;

            //connector.Connect(microphone, audioSender);
            //connector.Connect(audioReceiver, speaker);

            //audioSender.AttachToCall(call);
            //audioReceiver.AttachToCall(call);

            //microphone.Start();
            //speaker.Start();

            //started = true;
        }

        public void Stop()
        {
            //microphone.Stop();
            //speaker.Stop();

            //audioSender.Detach();
            //audioReceiver.Detach();

            //connector.Disconnect(microphone, audioSender);
            //connector.Disconnect(audioReceiver, speaker);

            //started = false;
        }

        public void Dispose()
        {
            if (connector != null)
                connector.Dispose();

            microphone.Dispose();
            speaker.Dispose();
            audioSender.Dispose();
            audioReceiver.Dispose();
        }        
    }
}
